// Byteseeker Jr.

#include <stdint.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#define SAMPLE_RATE 8000
byte ledPin = 13;
byte speakerPin = 11; // 11 is connected to Timer 2
int t=0;
unsigned int lastTime = 0;
unsigned int thisTime = 0;
volatile int a, b, c;
volatile int value;

const byte  buttonPin = 5;    // the pin that the Up pushbutton is attached to
const byte  buttonPin1 = 7;    // the pin that the Down pushbutton is attached to
byte state = 0;   // counter for the number of button presses
byte buttonState5 = 0;         // current state of the button
byte buttonState7 = 0;         // current state of the button
byte lastButtonState = 0;     // previous state of the button
byte nMAX = 17;
volatile int aTop=99;
volatile int aBottom=0;
volatile int bTop=99;
volatile int bBottom=0;
volatile int cTop=99;
volatile int cBottom=0;

void stopPlayback()
{
    // Disable playback per-sample interrupt.
    TIMSK1 &= ~_BV(OCIE1A);

    // Disable the per-sample timer completely.
    TCCR1B &= ~_BV(CS10);

    // Disable the PWM timer.
    TCCR2B &= ~_BV(CS10);

    digitalWrite(speakerPin, LOW);
    digitalWrite(ledPin, HIGH);
}

// This is called at 8000 Hz to load the next sample.
ISR(TIMER1_COMPA_vect) {

   switch (state) {
     
     case 0: 
         value = ((t*a)&(t*t>>b))|(t/c);  
         aTop = 1;
         aBottom =24;
         bTop = 14;
         bBottom = 1;
         cTop = 12;
         cBottom = 1;
         break;
      case 1: 
         value = (((t|((t>>a)))+(t&((t>>b))))|(t>>(a+1))&(t>>a)&(t*(t>>b)))/c;  
         aTop = 13;
         aBottom =1;
         bTop = 15;
         bBottom = 1;
         cTop = 15;
         cBottom = 1;
         break;
      case 2: 
         value =(t*(t>>(a/c)|t>>(b/c)))>>(t>>((b/c)*2)); 
         aTop = 20;
         aBottom =1;
         bTop = 20;
         bBottom = 1;
         cTop = 20;
         cBottom = 1;
         break;
      case 3:
        value = (t*(((t>>(a*3))|(t>>(10+a)))&(b&(t>>(a*2)))))/c;   
         aTop = 8;
         aBottom =2;
         bTop = 16;
         bBottom = 1;
         cTop = 8;
         cBottom = 1;
        break;
      case 4:
        value = t*(((t>>a+c)&(t>>8))&((b+73)&(t>>3)))|t*(c>>a-3);  
         aTop = 16;
         aBottom =1;
         bTop = 99;
         bBottom = 0;
         cTop = 1;
         cBottom = 13;
         break;
      case 5:
        value = t*(((t>>a)|(t>>(b*2)))&(63&(t>>b)))|t*(t>>a+c);   
         aTop = 20;
         aBottom = 1;
         bTop = 8;
         bBottom = 0;
         cTop = 9;
         cBottom = 1;
         break;
      case 6:
        value = ((t>>a&t)-(t>>a)+(t>>a&t))+(t*((t>>b)&b))-(t*((t>>c)&c)); 
         aTop = 10;
         aBottom = 0;
         bTop = 28;
         bBottom = 0;
         cTop = 9;
         cBottom = 1;
         break;
      case 7:
        value = ((t%c)*(t>>a)|(0x577338)-(t>>a))/(t>>b)^(t|(t>>a));  
         aTop = 8;
         aBottom = 0;
         bTop = 32;
         bBottom = 0;
         cTop = 128;
         cBottom = 16;
         break;
      case 8:
         value = (t>>a|t%c|t>>(t>>16))|b+((t>>(b+1))&(a+1))|(t*(t>>((t>>(c-(a+b)))+b/3)));   
         aTop = 12;
         aBottom = 0;
         bTop = 20;
         bBottom = 0;
         cTop = 99;
         cBottom = 1;
         break;
      case 9:
         value = t*(t>>a&t>>(a-3))^(t*(t%b))|t>>c&t>>(a-5);   
         aTop = 15;
         aBottom = 7;
         bTop = 10;
         bBottom = 1;
         cTop = 6;
         cBottom = 0;
         break;
      case 10:
         value = (t*a&t/c)|(t*b&t/(c*2))|t>>(c/3);   
         aTop = 1;
         aBottom = 56;
         bTop = 56;
         bBottom = 112;
         cTop = 15;
         cBottom = 1;
         break; 
      case 11:
         value = (((t>>c+2)&(t>>b-1)*t)-2)>>t*a&(t>>a-5)|(t>>b-2&t>>c-3)*t-1;   
         aTop = 14;
         aBottom = 1;
         bTop = 13;
         bBottom = 1;
         cTop = 12;
         cBottom = 1;
         break; 
      case 12:
         value = (t*1|t>>c)&t%a|t*c|t>>b-c&t*t>>c|t>>b&(t*b|t>>c/3);   
         aTop = 48;
         aBottom = 1;
         bTop = 19;
         bBottom = 2;
         cTop = 3;
         cBottom = 19;
         break; 
      case 13:
         value = ((t*a)/b)|t<<c;   
         aTop = 1;
         aBottom = 64;
         bTop = 32;
         bBottom = 1;
         cTop = 1;
         cBottom = 8;
         break;
     case 14:
         value = t*(((t>>a)^(t>>a)-1^(t>>b+1)^(t>>b)-1))|1%t^(t/c)|1%t;   
         aTop = 14;
         aBottom = 4;
         bTop = 14;
         bBottom = 4;
         cTop = 64;
         cBottom = 2;
         break; 
      case 15:
         value = t*(((t>>10)^(t>>10)-a))^3%(c+11)^t*(((t>>b)^(t>>b)-c))|9%(c+13);   
         aTop = 3;
         aBottom = 15;
         bTop = 16;
         bBottom = 1;
         cTop = 3;
         cBottom = 15;
         break; 
   case 16:
         value = (t/a)*((t>>11&t>>8|t<<b)/c);   
         aTop = 28;
         aBottom = 1;
         bTop = 14;
         bBottom = 1;
         cTop = 24;
         cBottom = 1;
         break; 
   case 17 :
         value = t*a^t/b%255*c;
         aTop = 12;
         aBottom = 1;
         bTop = 22;
         bBottom = 1;
         cTop = 22;
         cBottom = 1;
         break;
    }
    
    OCR2A = 0xff & value;
    ++t;
}

void startPlayback()
{
    pinMode(speakerPin, OUTPUT);
   digitalWrite(ledPin, LOW);
    // Set up Timer 2 to do pulse width modulation on the speaker
    // pin.

    // Use internal clock (datasheet p.160)
    ASSR &= ~(_BV(EXCLK) | _BV(AS2));

    // Set fast PWM mode  (p.157)
    TCCR2A |= _BV(WGM21) | _BV(WGM20);
    TCCR2B &= ~_BV(WGM22);

    // Do non-inverting PWM on pin OC2A (p.155)
    // On the Arduino this is pin 11.
    TCCR2A = (TCCR2A | _BV(COM2A1)) & ~_BV(COM2A0);
    TCCR2A &= ~(_BV(COM2B1) | _BV(COM2B0));
    // No prescaler (p.158)
    TCCR2B = (TCCR2B & ~(_BV(CS12) | _BV(CS11))) | _BV(CS10);

    // Set initial pulse width to the first sample.
    OCR2A = 0;

    // Set up Timer 1 to send a sample every interrupt.
    cli();

    // Set CTC mode (Clear Timer on Compare Match) (p.133)
    // Have to set OCR1A *after*, otherwise it gets reset to 0!
    TCCR1B = (TCCR1B & ~_BV(WGM13)) | _BV(WGM12);
    TCCR1A = TCCR1A & ~(_BV(WGM11) | _BV(WGM10));

    // No prescaler (p.134)
    TCCR1B = (TCCR1B & ~(_BV(CS12) | _BV(CS11))) | _BV(CS10);

    // Set the compare register (OCR1A).
    // OCR1A is a 16-bit register, so we have to do this with
    // interrupts disabled to be safe.
    OCR1A = F_CPU / SAMPLE_RATE;    // 16e6 / 8000 = 2000

    // Enable interrupt when TCNT1 == OCR1A (p.136)
    TIMSK1 |= _BV(OCIE1A);

    sei();
}

void blinkNTimes(int n) {
  for (int i=0; i<n; i++) {
    digitalWrite(13, HIGH);
    delay(20);
    digitalWrite(13, LOW);
    delay(250);
  }
}
  void blinkNTimEND (int n) 
  {
  for (int i=0; i<n; i++) {
    digitalWrite(13, HIGH);
    delay(30);
    digitalWrite(13, LOW);
    delay(30);
  }
}
void setup() {
    pinMode(ledPin, OUTPUT);
    digitalWrite(ledPin, LOW);
    pinMode(buttonPin, INPUT);
    digitalWrite(buttonPin, HIGH);
    pinMode(buttonPin1, INPUT);
    digitalWrite(buttonPin1, HIGH); // set pullup
    
    startPlayback();
    
    lastTime = millis();
    thisTime = millis();
}

void loop() {
     // Is this working? May be broken by the timer action above
    thisTime = millis();   
    if ((thisTime - lastTime) > 5) {
        //updateScreen();
        lastTime = thisTime;
         a = map(analogRead(0), 0, 1023, aBottom, aTop); 
         b = map(analogRead(1), 0, 1023, bBottom, bTop);
         c = map(analogRead(2), 0, 1023, cBottom, cTop);
            
   buttonState5 = digitalRead(buttonPin);
	
	if (buttonState5 != lastButtonState) 
	{
		
		if (buttonState5 == LOW)
		{ 
			if (state != nMAX)
			{
				state++;
				delay(100);
				int stateLED = state+1;
				blinkNTimes(stateLED);
			}
			else if (state == nMAX) 
			{
				blinkNTimEND(20);
				state = 0;
			}
			
		}
		
	}
	
	lastButtonState = buttonState5;
	
	buttonState7 = digitalRead(buttonPin1);
	
	if (buttonState7 != lastButtonState) {
		
		if (buttonState7 == LOW)
			
		{
			if (state != 0)
			{
				state--;
				delay(100);
				int stateLED = state+1;
				blinkNTimes(stateLED);
			}
			else if (state == 0)
			{ 
				blinkNTimEND(20);
				state = nMAX;
			}
		}
		
	}
	lastButtonState = buttonState7;
}
}
